from pathlib import Path

from models import Software


class LocalFile:
    def __init__(self, software: Software):
        self.software = software

    def get_files_in_folder(self) -> list[str]:
        return [file.name for file in Path(self.software.folder).glob("*")]

    def is_file_present(self):
        files = self.get_files_in_folder()
        return self.software.filename in files

    def is_file_absent(self):
        return not self.is_file_present()

    def write_file(self, file: bytes) -> None:
        self.software.absolute_path.write_bytes(file)

    def chmod(self, mode: oct) -> None:
        self.software.absolute_path.chmod(mode)

    def chmod_other_versions(self, mode: oct) -> None:
        others = Path(self.software.folder).glob(self.software.filename_pattern)
        print(list(others))
        for other in others:
            print(other.name)
            print(self.software.filename)
            if other.name != self.software.name:
                print(f"chmod {other.name}")
                other.chmod(mode)

    def delete_file(self):
        self.software.absolute_path.unlink()
